/* eslint-disable no-continue */
import { Client, Collection, Handler } from '.';

export default class PBX {
  public client: Client;

  public handlers: Collection<Handler>;

  constructor(client: Client) {
    this.client = client;

    this.handlers = new Collection<Handler>();

    this.start();
  }

  public start() {
    this.client.util.ari.on('ChannelHangupRequest', (_, channel) => channel.hangup());
    const handlers = Object.values<typeof Handler>(require(`${__dirname}/../pbx`));
    for (const HandlerFile of handlers) {
      const handler = new HandlerFile(this);
      if (!handler.app) continue;
      if (!handler.options?.available) {
        this.client.util.ari.on('StasisStart', async (event, channel) => {
          if (event.application !== handler.app) return;
          await handler.unavailable(event, channel);
        });
      } else {
        this.client.util.ari.on('StasisStart', async (event, channel) => {
          if (event.application !== handler.app) return;
          try {
            await handler.run(event, channel);
          } catch (err) {
            this.client.util.handleError(err);
          }
        });
      }
      this.handlers.add(handler.app, handler);
      this.client.util.signale.success(`Successfully loaded PBX Handler ${handler.app}`);
    }
  }
}
